unit schInventarioClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_INVENTARIO = '{EEDDC06C-8E96-434B-9DA3-1F49EA694DFA}';
  RID_DETALLE_RESERVAS_INV = '{C1CF7438-A7CF-4434-8E77-06B019ACFADC}';
  RID_DETALLE_SIN_ALBARANAR = '{FB4FBF7C-5C73-4A6D-8669-E9C2821F2386}';
  RID_DETALLE_SIN_RECIBIR = '{90278CE5-05F6-425B-985B-C1F560010326}';

  { Data table names }
  nme_INVENTARIO = 'INVENTARIO';
  nme_DETALLE_RESERVAS_INV = 'DETALLE_RESERVAS_INV';
  nme_DETALLE_SIN_ALBARANAR = 'DETALLE_SIN_ALBARANAR';
  nme_DETALLE_SIN_RECIBIR = 'DETALLE_SIN_RECIBIR';

  { INVENTARIO fields }
  fld_INVENTARIOID = 'ID';
  fld_INVENTARIOID_ALMACEN = 'ID_ALMACEN';
  fld_INVENTARIOID_ARTICULO = 'ID_ARTICULO';
  fld_INVENTARIOALMACEN = 'ALMACEN';
  fld_INVENTARIOID_EMPRESA = 'ID_EMPRESA';
  fld_INVENTARIOREFERENCIA = 'REFERENCIA';
  fld_INVENTARIOFAMILIA = 'FAMILIA';
  fld_INVENTARIODESCRIPCION = 'DESCRIPCION';
  fld_INVENTARIOPRECIO_NETO = 'PRECIO_NETO';
  fld_INVENTARIOREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_INVENTARIOUNIDADES_ALMACEN = 'UNIDADES_ALMACEN';
  fld_INVENTARIOCOSTE_UNIDADES = 'COSTE_UNIDADES';
  fld_INVENTARIOSTOCK = 'STOCK';
  fld_INVENTARIORESERVA = 'RESERVA';
  fld_INVENTARIOPENDIENTE_RECEPCION = 'PENDIENTE_RECEPCION';
  fld_INVENTARIOCANTIDAD = 'CANTIDAD';
  fld_INVENTARIOFECHA_MOVIMIENTO = 'FECHA_MOVIMIENTO';
  fld_INVENTARIOCAUSA = 'CAUSA';
  fld_INVENTARIOTIPO = 'TIPO';

  { INVENTARIO field indexes }
  idx_INVENTARIOID = 0;
  idx_INVENTARIOID_ALMACEN = 1;
  idx_INVENTARIOID_ARTICULO = 2;
  idx_INVENTARIOALMACEN = 3;
  idx_INVENTARIOID_EMPRESA = 4;
  idx_INVENTARIOREFERENCIA = 5;
  idx_INVENTARIOFAMILIA = 6;
  idx_INVENTARIODESCRIPCION = 7;
  idx_INVENTARIOPRECIO_NETO = 8;
  idx_INVENTARIOREFERENCIA_PROVEEDOR = 9;
  idx_INVENTARIOUNIDADES_ALMACEN = 10;
  idx_INVENTARIOCOSTE_UNIDADES = 11;
  idx_INVENTARIOSTOCK = 12;
  idx_INVENTARIORESERVA = 13;
  idx_INVENTARIOPENDIENTE_RECEPCION = 14;
  idx_INVENTARIOCANTIDAD = 15;
  idx_INVENTARIOFECHA_MOVIMIENTO = 16;
  idx_INVENTARIOCAUSA = 17;
  idx_INVENTARIOTIPO = 18;

  { DETALLE_RESERVAS_INV fields }
  fld_DETALLE_RESERVAS_INVID_ALB = 'ID_ALB';
  fld_DETALLE_RESERVAS_INVID_EMPRESA = 'ID_EMPRESA';
  fld_DETALLE_RESERVAS_INVREFERENCIA_ALB = 'REFERENCIA_ALB';
  fld_DETALLE_RESERVAS_INVSITUACION_ALB = 'SITUACION_ALB';
  fld_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB = 'FECHA_PREVISTA_ENVIO_ALB';
  fld_DETALLE_RESERVAS_INVID_ALMACEN_ALB = 'ID_ALMACEN_ALB';
  fld_DETALLE_RESERVAS_INVALMACEN_ALB = 'ALMACEN_ALB';
  fld_DETALLE_RESERVAS_INVID_CLIENTE_ALB = 'ID_CLIENTE_ALB';
  fld_DETALLE_RESERVAS_INVCLIENTE_ALB = 'CLIENTE_ALB';
  fld_DETALLE_RESERVAS_INVID_ART = 'ID_ART';
  fld_DETALLE_RESERVAS_INVFAMILIA_ART = 'FAMILIA_ART';
  fld_DETALLE_RESERVAS_INVREFERENCIA_ART = 'REFERENCIA_ART';
  fld_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART = 'REFERENCIA_PROV_ART';
  fld_DETALLE_RESERVAS_INVDESCRIPCION_ART = 'DESCRIPCION_ART';
  fld_DETALLE_RESERVAS_INVCANTIDAD_ART = 'CANTIDAD_ART';

  { DETALLE_RESERVAS_INV field indexes }
  idx_DETALLE_RESERVAS_INVID_ALB = 0;
  idx_DETALLE_RESERVAS_INVID_EMPRESA = 1;
  idx_DETALLE_RESERVAS_INVREFERENCIA_ALB = 2;
  idx_DETALLE_RESERVAS_INVSITUACION_ALB = 3;
  idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB = 4;
  idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB = 5;
  idx_DETALLE_RESERVAS_INVALMACEN_ALB = 6;
  idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB = 7;
  idx_DETALLE_RESERVAS_INVCLIENTE_ALB = 8;
  idx_DETALLE_RESERVAS_INVID_ART = 9;
  idx_DETALLE_RESERVAS_INVFAMILIA_ART = 10;
  idx_DETALLE_RESERVAS_INVREFERENCIA_ART = 11;
  idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART = 12;
  idx_DETALLE_RESERVAS_INVDESCRIPCION_ART = 13;
  idx_DETALLE_RESERVAS_INVCANTIDAD_ART = 14;

  { DETALLE_SIN_ALBARANAR fields }
  fld_DETALLE_SIN_ALBARANARID_PEDIDO = 'ID_PEDIDO';
  fld_DETALLE_SIN_ALBARANARID_EMPRESA = 'ID_EMPRESA';
  fld_DETALLE_SIN_ALBARANARREFERENCIA_CLI_PEDIDO = 'REFERENCIA_CLI_PEDIDO';
  fld_DETALLE_SIN_ALBARANARREFERENCIA_PEDIDO = 'REFERENCIA_PEDIDO';
  fld_DETALLE_SIN_ALBARANARFECHA_PEDIDO = 'FECHA_PEDIDO';
  fld_DETALLE_SIN_ALBARANARFECHA_PREVISTA_PEDIDO = 'FECHA_PREVISTA_PEDIDO';
  fld_DETALLE_SIN_ALBARANARID_CLIENTE = 'ID_CLIENTE';
  fld_DETALLE_SIN_ALBARANARCLIENTE = 'CLIENTE';
  fld_DETALLE_SIN_ALBARANARCALLE = 'CALLE';
  fld_DETALLE_SIN_ALBARANARCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_DETALLE_SIN_ALBARANARPOBLACION = 'POBLACION';
  fld_DETALLE_SIN_ALBARANARPROVINCIA = 'PROVINCIA';
  fld_DETALLE_SIN_ALBARANARPERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_DETALLE_SIN_ALBARANARTELEFONO = 'TELEFONO';
  fld_DETALLE_SIN_ALBARANARIVA = 'IVA';
  fld_DETALLE_SIN_ALBARANARID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_DETALLE_SIN_ALBARANARID = 'ID';
  fld_DETALLE_SIN_ALBARANARID_ARTICULO = 'ID_ARTICULO';
  fld_DETALLE_SIN_ALBARANARFAMILIA = 'FAMILIA';
  fld_DETALLE_SIN_ALBARANARREFERENCIA = 'REFERENCIA';
  fld_DETALLE_SIN_ALBARANARREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_DETALLE_SIN_ALBARANARDESCRIPCION = 'DESCRIPCION';
  fld_DETALLE_SIN_ALBARANARCANTIDAD_PEDIDA = 'CANTIDAD_PEDIDA';
  fld_DETALLE_SIN_ALBARANARCANTIDAD_RESERVADA = 'CANTIDAD_RESERVADA';
  fld_DETALLE_SIN_ALBARANARCANTIDAD_ENVIADA = 'CANTIDAD_ENVIADA';
  fld_DETALLE_SIN_ALBARANARCANTIDAD_SERVIDA = 'CANTIDAD_SERVIDA';
  fld_DETALLE_SIN_ALBARANARCANTIDAD_PENDIENTE = 'CANTIDAD_PENDIENTE';
  fld_DETALLE_SIN_ALBARANARPRECIO_COSTE = 'PRECIO_COSTE';
  fld_DETALLE_SIN_ALBARANARDESCUENTO = 'DESCUENTO';
  fld_DETALLE_SIN_ALBARANARPRECION_NETO = 'PRECION_NETO';

  { DETALLE_SIN_ALBARANAR field indexes }
  idx_DETALLE_SIN_ALBARANARID_PEDIDO = 0;
  idx_DETALLE_SIN_ALBARANARID_EMPRESA = 1;
  idx_DETALLE_SIN_ALBARANARREFERENCIA_CLI_PEDIDO = 2;
  idx_DETALLE_SIN_ALBARANARREFERENCIA_PEDIDO = 3;
  idx_DETALLE_SIN_ALBARANARFECHA_PEDIDO = 4;
  idx_DETALLE_SIN_ALBARANARFECHA_PREVISTA_PEDIDO = 5;
  idx_DETALLE_SIN_ALBARANARID_CLIENTE = 6;
  idx_DETALLE_SIN_ALBARANARCLIENTE = 7;
  idx_DETALLE_SIN_ALBARANARCALLE = 8;
  idx_DETALLE_SIN_ALBARANARCODIGO_POSTAL = 9;
  idx_DETALLE_SIN_ALBARANARPOBLACION = 10;
  idx_DETALLE_SIN_ALBARANARPROVINCIA = 11;
  idx_DETALLE_SIN_ALBARANARPERSONA_CONTACTO = 12;
  idx_DETALLE_SIN_ALBARANARTELEFONO = 13;
  idx_DETALLE_SIN_ALBARANARIVA = 14;
  idx_DETALLE_SIN_ALBARANARID_FORMA_PAGO = 15;
  idx_DETALLE_SIN_ALBARANARID = 16;
  idx_DETALLE_SIN_ALBARANARID_ARTICULO = 17;
  idx_DETALLE_SIN_ALBARANARFAMILIA = 18;
  idx_DETALLE_SIN_ALBARANARREFERENCIA = 19;
  idx_DETALLE_SIN_ALBARANARREFERENCIA_PROVEEDOR = 20;
  idx_DETALLE_SIN_ALBARANARDESCRIPCION = 21;
  idx_DETALLE_SIN_ALBARANARCANTIDAD_PEDIDA = 22;
  idx_DETALLE_SIN_ALBARANARCANTIDAD_RESERVADA = 23;
  idx_DETALLE_SIN_ALBARANARCANTIDAD_ENVIADA = 24;
  idx_DETALLE_SIN_ALBARANARCANTIDAD_SERVIDA = 25;
  idx_DETALLE_SIN_ALBARANARCANTIDAD_PENDIENTE = 26;
  idx_DETALLE_SIN_ALBARANARPRECIO_COSTE = 27;
  idx_DETALLE_SIN_ALBARANARDESCUENTO = 28;
  idx_DETALLE_SIN_ALBARANARPRECION_NETO = 29;

  { DETALLE_SIN_RECIBIR fields }
  fld_DETALLE_SIN_RECIBIRID_PEDIDO = 'ID_PEDIDO';
  fld_DETALLE_SIN_RECIBIRID_EMPRESA = 'ID_EMPRESA';
  fld_DETALLE_SIN_RECIBIRREFERENCIA_PEDIDO = 'REFERENCIA_PEDIDO';
  fld_DETALLE_SIN_RECIBIRFECHA_PEDIDO = 'FECHA_PEDIDO';
  fld_DETALLE_SIN_RECIBIRCALLE = 'CALLE';
  fld_DETALLE_SIN_RECIBIRFECHA_CONFIRMACION = 'FECHA_CONFIRMACION';
  fld_DETALLE_SIN_RECIBIRID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_DETALLE_SIN_RECIBIRCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_DETALLE_SIN_RECIBIRPOBLACION = 'POBLACION';
  fld_DETALLE_SIN_RECIBIRPROVINCIA = 'PROVINCIA';
  fld_DETALLE_SIN_RECIBIRPERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_DETALLE_SIN_RECIBIRTELEFONO = 'TELEFONO';
  fld_DETALLE_SIN_RECIBIRIVA = 'IVA';
  fld_DETALLE_SIN_RECIBIRID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_DETALLE_SIN_RECIBIRID = 'ID';
  fld_DETALLE_SIN_RECIBIRPROVEEDOR = 'PROVEEDOR';
  fld_DETALLE_SIN_RECIBIRID_ARTICULO = 'ID_ARTICULO';
  fld_DETALLE_SIN_RECIBIRFAMILIA = 'FAMILIA';
  fld_DETALLE_SIN_RECIBIRREFERENCIA = 'REFERENCIA';
  fld_DETALLE_SIN_RECIBIRREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_DETALLE_SIN_RECIBIRDESCRIPCION = 'DESCRIPCION';
  fld_DETALLE_SIN_RECIBIRCANTIDAD_PEDIDA = 'CANTIDAD_PEDIDA';
  fld_DETALLE_SIN_RECIBIRCANTIDAD_RECIBIDA = 'CANTIDAD_RECIBIDA';
  fld_DETALLE_SIN_RECIBIRCANTIDAD_PENDIENTE = 'CANTIDAD_PENDIENTE';
  fld_DETALLE_SIN_RECIBIRPRECIO_COSTE = 'PRECIO_COSTE';
  fld_DETALLE_SIN_RECIBIRDESCUENTO = 'DESCUENTO';
  fld_DETALLE_SIN_RECIBIRPRECIO_NETO = 'PRECIO_NETO';
  fld_DETALLE_SIN_RECIBIRPRECIO_PORTE = 'PRECIO_PORTE';

  { DETALLE_SIN_RECIBIR field indexes }
  idx_DETALLE_SIN_RECIBIRID_PEDIDO = 0;
  idx_DETALLE_SIN_RECIBIRID_EMPRESA = 1;
  idx_DETALLE_SIN_RECIBIRREFERENCIA_PEDIDO = 2;
  idx_DETALLE_SIN_RECIBIRFECHA_PEDIDO = 3;
  idx_DETALLE_SIN_RECIBIRCALLE = 4;
  idx_DETALLE_SIN_RECIBIRFECHA_CONFIRMACION = 5;
  idx_DETALLE_SIN_RECIBIRID_PROVEEDOR = 6;
  idx_DETALLE_SIN_RECIBIRCODIGO_POSTAL = 7;
  idx_DETALLE_SIN_RECIBIRPOBLACION = 8;
  idx_DETALLE_SIN_RECIBIRPROVINCIA = 9;
  idx_DETALLE_SIN_RECIBIRPERSONA_CONTACTO = 10;
  idx_DETALLE_SIN_RECIBIRTELEFONO = 11;
  idx_DETALLE_SIN_RECIBIRIVA = 12;
  idx_DETALLE_SIN_RECIBIRID_FORMA_PAGO = 13;
  idx_DETALLE_SIN_RECIBIRID = 14;
  idx_DETALLE_SIN_RECIBIRPROVEEDOR = 15;
  idx_DETALLE_SIN_RECIBIRID_ARTICULO = 16;
  idx_DETALLE_SIN_RECIBIRFAMILIA = 17;
  idx_DETALLE_SIN_RECIBIRREFERENCIA = 18;
  idx_DETALLE_SIN_RECIBIRREFERENCIA_PROVEEDOR = 19;
  idx_DETALLE_SIN_RECIBIRDESCRIPCION = 20;
  idx_DETALLE_SIN_RECIBIRCANTIDAD_PEDIDA = 21;
  idx_DETALLE_SIN_RECIBIRCANTIDAD_RECIBIDA = 22;
  idx_DETALLE_SIN_RECIBIRCANTIDAD_PENDIENTE = 23;
  idx_DETALLE_SIN_RECIBIRPRECIO_COSTE = 24;
  idx_DETALLE_SIN_RECIBIRDESCUENTO = 25;
  idx_DETALLE_SIN_RECIBIRPRECIO_NETO = 26;
  idx_DETALLE_SIN_RECIBIRPRECIO_PORTE = 27;

type
  { IINVENTARIO }
  IINVENTARIO = interface(IDAStronglyTypedDataTable)
  ['{2DE936D7-2F07-4408-B26A-6453B08FC9FF}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetALMACENValue: String;
    procedure SetALMACENValue(const aValue: String);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetPRECIO_NETOValue: Currency;
    procedure SetPRECIO_NETOValue(const aValue: Currency);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetUNIDADES_ALMACENValue: Integer;
    procedure SetUNIDADES_ALMACENValue(const aValue: Integer);
    function GetCOSTE_UNIDADESValue: Currency;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency);
    function GetSTOCKValue: Integer;
    procedure SetSTOCKValue(const aValue: Integer);
    function GetRESERVAValue: Integer;
    procedure SetRESERVAValue(const aValue: Integer);
    function GetPENDIENTE_RECEPCIONValue: Integer;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Integer);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetFECHA_MOVIMIENTOValue: DateTime;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
    function GetCAUSAValue: String;
    procedure SetCAUSAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property UNIDADES_ALMACEN: Integer read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property STOCK: Integer read GetSTOCKValue write SetSTOCKValue;
    property RESERVA: Integer read GetRESERVAValue write SetRESERVAValue;
    property PENDIENTE_RECEPCION: Integer read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
  end;

  { TINVENTARIODataTableRules }
  TINVENTARIODataTableRules = class(TDADataTableRules, IINVENTARIO)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetALMACENValue: String; virtual;
    procedure SetALMACENValue(const aValue: String); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetPRECIO_NETOValue: Currency; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Currency); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetUNIDADES_ALMACENValue: Integer; virtual;
    procedure SetUNIDADES_ALMACENValue(const aValue: Integer); virtual;
    function GetCOSTE_UNIDADESValue: Currency; virtual;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency); virtual;
    function GetSTOCKValue: Integer; virtual;
    procedure SetSTOCKValue(const aValue: Integer); virtual;
    function GetRESERVAValue: Integer; virtual;
    procedure SetRESERVAValue(const aValue: Integer); virtual;
    function GetPENDIENTE_RECEPCIONValue: Integer; virtual;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Integer); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetFECHA_MOVIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime); virtual;
    function GetCAUSAValue: String; virtual;
    procedure SetCAUSAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property UNIDADES_ALMACEN: Integer read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property STOCK: Integer read GetSTOCKValue write SetSTOCKValue;
    property RESERVA: Integer read GetRESERVAValue write SetRESERVAValue;
    property PENDIENTE_RECEPCION: Integer read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDETALLE_RESERVAS_INV }
  IDETALLE_RESERVAS_INV = interface(IDAStronglyTypedDataTable)
  ['{8530D65C-47B4-47CB-B05B-95DAC2A8A44E}']
    { Property getters and setters }
    function GetID_ALBValue: Integer;
    procedure SetID_ALBValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIA_ALBValue: String;
    procedure SetREFERENCIA_ALBValue(const aValue: String);
    function GetSITUACION_ALBValue: String;
    procedure SetSITUACION_ALBValue(const aValue: String);
    function GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime;
    procedure SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime);
    function GetID_ALMACEN_ALBValue: Integer;
    procedure SetID_ALMACEN_ALBValue(const aValue: Integer);
    function GetALMACEN_ALBValue: String;
    procedure SetALMACEN_ALBValue(const aValue: String);
    function GetID_CLIENTE_ALBValue: Integer;
    procedure SetID_CLIENTE_ALBValue(const aValue: Integer);
    function GetCLIENTE_ALBValue: String;
    procedure SetCLIENTE_ALBValue(const aValue: String);
    function GetID_ARTValue: Integer;
    procedure SetID_ARTValue(const aValue: Integer);
    function GetFAMILIA_ARTValue: String;
    procedure SetFAMILIA_ARTValue(const aValue: String);
    function GetREFERENCIA_ARTValue: String;
    procedure SetREFERENCIA_ARTValue(const aValue: String);
    function GetREFERENCIA_PROV_ARTValue: String;
    procedure SetREFERENCIA_PROV_ARTValue(const aValue: String);
    function GetDESCRIPCION_ARTValue: String;
    procedure SetDESCRIPCION_ARTValue(const aValue: String);
    function GetCANTIDAD_ARTValue: Integer;
    procedure SetCANTIDAD_ARTValue(const aValue: Integer);


    { Properties }
    property ID_ALB: Integer read GetID_ALBValue write SetID_ALBValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_ALB: String read GetREFERENCIA_ALBValue write SetREFERENCIA_ALBValue;
    property SITUACION_ALB: String read GetSITUACION_ALBValue write SetSITUACION_ALBValue;
    property FECHA_PREVISTA_ENVIO_ALB: DateTime read GetFECHA_PREVISTA_ENVIO_ALBValue write SetFECHA_PREVISTA_ENVIO_ALBValue;
    property ID_ALMACEN_ALB: Integer read GetID_ALMACEN_ALBValue write SetID_ALMACEN_ALBValue;
    property ALMACEN_ALB: String read GetALMACEN_ALBValue write SetALMACEN_ALBValue;
    property ID_CLIENTE_ALB: Integer read GetID_CLIENTE_ALBValue write SetID_CLIENTE_ALBValue;
    property CLIENTE_ALB: String read GetCLIENTE_ALBValue write SetCLIENTE_ALBValue;
    property ID_ART: Integer read GetID_ARTValue write SetID_ARTValue;
    property FAMILIA_ART: String read GetFAMILIA_ARTValue write SetFAMILIA_ARTValue;
    property REFERENCIA_ART: String read GetREFERENCIA_ARTValue write SetREFERENCIA_ARTValue;
    property REFERENCIA_PROV_ART: String read GetREFERENCIA_PROV_ARTValue write SetREFERENCIA_PROV_ARTValue;
    property DESCRIPCION_ART: String read GetDESCRIPCION_ARTValue write SetDESCRIPCION_ARTValue;
    property CANTIDAD_ART: Integer read GetCANTIDAD_ARTValue write SetCANTIDAD_ARTValue;
  end;

  { TDETALLE_RESERVAS_INVDataTableRules }
  TDETALLE_RESERVAS_INVDataTableRules = class(TDADataTableRules, IDETALLE_RESERVAS_INV)
  private
  protected
    { Property getters and setters }
    function GetID_ALBValue: Integer; virtual;
    procedure SetID_ALBValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_ALBValue: String; virtual;
    procedure SetREFERENCIA_ALBValue(const aValue: String); virtual;
    function GetSITUACION_ALBValue: String; virtual;
    procedure SetSITUACION_ALBValue(const aValue: String); virtual;
    function GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime; virtual;
    procedure SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime); virtual;
    function GetID_ALMACEN_ALBValue: Integer; virtual;
    procedure SetID_ALMACEN_ALBValue(const aValue: Integer); virtual;
    function GetALMACEN_ALBValue: String; virtual;
    procedure SetALMACEN_ALBValue(const aValue: String); virtual;
    function GetID_CLIENTE_ALBValue: Integer; virtual;
    procedure SetID_CLIENTE_ALBValue(const aValue: Integer); virtual;
    function GetCLIENTE_ALBValue: String; virtual;
    procedure SetCLIENTE_ALBValue(const aValue: String); virtual;
    function GetID_ARTValue: Integer; virtual;
    procedure SetID_ARTValue(const aValue: Integer); virtual;
    function GetFAMILIA_ARTValue: String; virtual;
    procedure SetFAMILIA_ARTValue(const aValue: String); virtual;
    function GetREFERENCIA_ARTValue: String; virtual;
    procedure SetREFERENCIA_ARTValue(const aValue: String); virtual;
    function GetREFERENCIA_PROV_ARTValue: String; virtual;
    procedure SetREFERENCIA_PROV_ARTValue(const aValue: String); virtual;
    function GetDESCRIPCION_ARTValue: String; virtual;
    procedure SetDESCRIPCION_ARTValue(const aValue: String); virtual;
    function GetCANTIDAD_ARTValue: Integer; virtual;
    procedure SetCANTIDAD_ARTValue(const aValue: Integer); virtual;

    { Properties }
    property ID_ALB: Integer read GetID_ALBValue write SetID_ALBValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_ALB: String read GetREFERENCIA_ALBValue write SetREFERENCIA_ALBValue;
    property SITUACION_ALB: String read GetSITUACION_ALBValue write SetSITUACION_ALBValue;
    property FECHA_PREVISTA_ENVIO_ALB: DateTime read GetFECHA_PREVISTA_ENVIO_ALBValue write SetFECHA_PREVISTA_ENVIO_ALBValue;
    property ID_ALMACEN_ALB: Integer read GetID_ALMACEN_ALBValue write SetID_ALMACEN_ALBValue;
    property ALMACEN_ALB: String read GetALMACEN_ALBValue write SetALMACEN_ALBValue;
    property ID_CLIENTE_ALB: Integer read GetID_CLIENTE_ALBValue write SetID_CLIENTE_ALBValue;
    property CLIENTE_ALB: String read GetCLIENTE_ALBValue write SetCLIENTE_ALBValue;
    property ID_ART: Integer read GetID_ARTValue write SetID_ARTValue;
    property FAMILIA_ART: String read GetFAMILIA_ARTValue write SetFAMILIA_ARTValue;
    property REFERENCIA_ART: String read GetREFERENCIA_ARTValue write SetREFERENCIA_ARTValue;
    property REFERENCIA_PROV_ART: String read GetREFERENCIA_PROV_ARTValue write SetREFERENCIA_PROV_ARTValue;
    property DESCRIPCION_ART: String read GetDESCRIPCION_ARTValue write SetDESCRIPCION_ARTValue;
    property CANTIDAD_ART: Integer read GetCANTIDAD_ARTValue write SetCANTIDAD_ARTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDETALLE_SIN_ALBARANAR }
  IDETALLE_SIN_ALBARANAR = interface(IDAStronglyTypedDataTable)
  ['{2E09F69C-DDF7-4D84-9020-83B92CE2F7AC}']
    { Property getters and setters }
    function GetID_PEDIDOValue: Integer;
    procedure SetID_PEDIDOValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIA_CLI_PEDIDOValue: String;
    procedure SetREFERENCIA_CLI_PEDIDOValue(const aValue: String);
    function GetREFERENCIA_PEDIDOValue: String;
    procedure SetREFERENCIA_PEDIDOValue(const aValue: String);
    function GetFECHA_PEDIDOValue: DateTime;
    procedure SetFECHA_PEDIDOValue(const aValue: DateTime);
    function GetFECHA_PREVISTA_PEDIDOValue: DateTime;
    procedure SetFECHA_PREVISTA_PEDIDOValue(const aValue: DateTime);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetCLIENTEValue: String;
    procedure SetCLIENTEValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetTELEFONOValue: String;
    procedure SetTELEFONOValue(const aValue: String);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetCANTIDAD_PEDIDAValue: Integer;
    procedure SetCANTIDAD_PEDIDAValue(const aValue: Integer);
    function GetCANTIDAD_RESERVADAValue: Integer;
    procedure SetCANTIDAD_RESERVADAValue(const aValue: Integer);
    function GetCANTIDAD_ENVIADAValue: Integer;
    procedure SetCANTIDAD_ENVIADAValue(const aValue: Integer);
    function GetCANTIDAD_SERVIDAValue: Integer;
    procedure SetCANTIDAD_SERVIDAValue(const aValue: Integer);
    function GetCANTIDAD_PENDIENTEValue: Integer;
    procedure SetCANTIDAD_PENDIENTEValue(const aValue: Integer);
    function GetPRECIO_COSTEValue: Currency;
    procedure SetPRECIO_COSTEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetPRECION_NETOValue: Currency;
    procedure SetPRECION_NETOValue(const aValue: Currency);


    { Properties }
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_CLI_PEDIDO: String read GetREFERENCIA_CLI_PEDIDOValue write SetREFERENCIA_CLI_PEDIDOValue;
    property REFERENCIA_PEDIDO: String read GetREFERENCIA_PEDIDOValue write SetREFERENCIA_PEDIDOValue;
    property FECHA_PEDIDO: DateTime read GetFECHA_PEDIDOValue write SetFECHA_PEDIDOValue;
    property FECHA_PREVISTA_PEDIDO: DateTime read GetFECHA_PREVISTA_PEDIDOValue write SetFECHA_PREVISTA_PEDIDOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property CANTIDAD_PEDIDA: Integer read GetCANTIDAD_PEDIDAValue write SetCANTIDAD_PEDIDAValue;
    property CANTIDAD_RESERVADA: Integer read GetCANTIDAD_RESERVADAValue write SetCANTIDAD_RESERVADAValue;
    property CANTIDAD_ENVIADA: Integer read GetCANTIDAD_ENVIADAValue write SetCANTIDAD_ENVIADAValue;
    property CANTIDAD_SERVIDA: Integer read GetCANTIDAD_SERVIDAValue write SetCANTIDAD_SERVIDAValue;
    property CANTIDAD_PENDIENTE: Integer read GetCANTIDAD_PENDIENTEValue write SetCANTIDAD_PENDIENTEValue;
    property PRECIO_COSTE: Currency read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property PRECION_NETO: Currency read GetPRECION_NETOValue write SetPRECION_NETOValue;
  end;

  { TDETALLE_SIN_ALBARANARDataTableRules }
  TDETALLE_SIN_ALBARANARDataTableRules = class(TDADataTableRules, IDETALLE_SIN_ALBARANAR)
  private
  protected
    { Property getters and setters }
    function GetID_PEDIDOValue: Integer; virtual;
    procedure SetID_PEDIDOValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_CLI_PEDIDOValue: String; virtual;
    procedure SetREFERENCIA_CLI_PEDIDOValue(const aValue: String); virtual;
    function GetREFERENCIA_PEDIDOValue: String; virtual;
    procedure SetREFERENCIA_PEDIDOValue(const aValue: String); virtual;
    function GetFECHA_PEDIDOValue: DateTime; virtual;
    procedure SetFECHA_PEDIDOValue(const aValue: DateTime); virtual;
    function GetFECHA_PREVISTA_PEDIDOValue: DateTime; virtual;
    procedure SetFECHA_PREVISTA_PEDIDOValue(const aValue: DateTime); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetCLIENTEValue: String; virtual;
    procedure SetCLIENTEValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetTELEFONOValue: String; virtual;
    procedure SetTELEFONOValue(const aValue: String); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetCANTIDAD_PEDIDAValue: Integer; virtual;
    procedure SetCANTIDAD_PEDIDAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_RESERVADAValue: Integer; virtual;
    procedure SetCANTIDAD_RESERVADAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_ENVIADAValue: Integer; virtual;
    procedure SetCANTIDAD_ENVIADAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_SERVIDAValue: Integer; virtual;
    procedure SetCANTIDAD_SERVIDAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_PENDIENTEValue: Integer; virtual;
    procedure SetCANTIDAD_PENDIENTEValue(const aValue: Integer); virtual;
    function GetPRECIO_COSTEValue: Currency; virtual;
    procedure SetPRECIO_COSTEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetPRECION_NETOValue: Currency; virtual;
    procedure SetPRECION_NETOValue(const aValue: Currency); virtual;

    { Properties }
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_CLI_PEDIDO: String read GetREFERENCIA_CLI_PEDIDOValue write SetREFERENCIA_CLI_PEDIDOValue;
    property REFERENCIA_PEDIDO: String read GetREFERENCIA_PEDIDOValue write SetREFERENCIA_PEDIDOValue;
    property FECHA_PEDIDO: DateTime read GetFECHA_PEDIDOValue write SetFECHA_PEDIDOValue;
    property FECHA_PREVISTA_PEDIDO: DateTime read GetFECHA_PREVISTA_PEDIDOValue write SetFECHA_PREVISTA_PEDIDOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property CANTIDAD_PEDIDA: Integer read GetCANTIDAD_PEDIDAValue write SetCANTIDAD_PEDIDAValue;
    property CANTIDAD_RESERVADA: Integer read GetCANTIDAD_RESERVADAValue write SetCANTIDAD_RESERVADAValue;
    property CANTIDAD_ENVIADA: Integer read GetCANTIDAD_ENVIADAValue write SetCANTIDAD_ENVIADAValue;
    property CANTIDAD_SERVIDA: Integer read GetCANTIDAD_SERVIDAValue write SetCANTIDAD_SERVIDAValue;
    property CANTIDAD_PENDIENTE: Integer read GetCANTIDAD_PENDIENTEValue write SetCANTIDAD_PENDIENTEValue;
    property PRECIO_COSTE: Currency read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property PRECION_NETO: Currency read GetPRECION_NETOValue write SetPRECION_NETOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDETALLE_SIN_RECIBIR }
  IDETALLE_SIN_RECIBIR = interface(IDAStronglyTypedDataTable)
  ['{8656D160-7755-4684-BA51-6C5B88AB8ADD}']
    { Property getters and setters }
    function GetID_PEDIDOValue: Integer;
    procedure SetID_PEDIDOValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIA_PEDIDOValue: String;
    procedure SetREFERENCIA_PEDIDOValue(const aValue: String);
    function GetFECHA_PEDIDOValue: DateTime;
    procedure SetFECHA_PEDIDOValue(const aValue: DateTime);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetFECHA_CONFIRMACIONValue: DateTime;
    procedure SetFECHA_CONFIRMACIONValue(const aValue: DateTime);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetTELEFONOValue: String;
    procedure SetTELEFONOValue(const aValue: String);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetPROVEEDORValue: String;
    procedure SetPROVEEDORValue(const aValue: String);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetCANTIDAD_PEDIDAValue: Integer;
    procedure SetCANTIDAD_PEDIDAValue(const aValue: Integer);
    function GetCANTIDAD_RECIBIDAValue: Integer;
    procedure SetCANTIDAD_RECIBIDAValue(const aValue: Integer);
    function GetCANTIDAD_PENDIENTEValue: Integer;
    procedure SetCANTIDAD_PENDIENTEValue(const aValue: Integer);
    function GetPRECIO_COSTEValue: Currency;
    procedure SetPRECIO_COSTEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetPRECIO_NETOValue: Float;
    procedure SetPRECIO_NETOValue(const aValue: Float);
    function GetPRECIO_PORTEValue: Float;
    procedure SetPRECIO_PORTEValue(const aValue: Float);


    { Properties }
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_PEDIDO: String read GetREFERENCIA_PEDIDOValue write SetREFERENCIA_PEDIDOValue;
    property FECHA_PEDIDO: DateTime read GetFECHA_PEDIDOValue write SetFECHA_PEDIDOValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property FECHA_CONFIRMACION: DateTime read GetFECHA_CONFIRMACIONValue write SetFECHA_CONFIRMACIONValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property CANTIDAD_PEDIDA: Integer read GetCANTIDAD_PEDIDAValue write SetCANTIDAD_PEDIDAValue;
    property CANTIDAD_RECIBIDA: Integer read GetCANTIDAD_RECIBIDAValue write SetCANTIDAD_RECIBIDAValue;
    property CANTIDAD_PENDIENTE: Integer read GetCANTIDAD_PENDIENTEValue write SetCANTIDAD_PENDIENTEValue;
    property PRECIO_COSTE: Currency read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property PRECIO_NETO: Float read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property PRECIO_PORTE: Float read GetPRECIO_PORTEValue write SetPRECIO_PORTEValue;
  end;

  { TDETALLE_SIN_RECIBIRDataTableRules }
  TDETALLE_SIN_RECIBIRDataTableRules = class(TDADataTableRules, IDETALLE_SIN_RECIBIR)
  private
  protected
    { Property getters and setters }
    function GetID_PEDIDOValue: Integer; virtual;
    procedure SetID_PEDIDOValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_PEDIDOValue: String; virtual;
    procedure SetREFERENCIA_PEDIDOValue(const aValue: String); virtual;
    function GetFECHA_PEDIDOValue: DateTime; virtual;
    procedure SetFECHA_PEDIDOValue(const aValue: DateTime); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetFECHA_CONFIRMACIONValue: DateTime; virtual;
    procedure SetFECHA_CONFIRMACIONValue(const aValue: DateTime); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetTELEFONOValue: String; virtual;
    procedure SetTELEFONOValue(const aValue: String); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetPROVEEDORValue: String; virtual;
    procedure SetPROVEEDORValue(const aValue: String); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetCANTIDAD_PEDIDAValue: Integer; virtual;
    procedure SetCANTIDAD_PEDIDAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_RECIBIDAValue: Integer; virtual;
    procedure SetCANTIDAD_RECIBIDAValue(const aValue: Integer); virtual;
    function GetCANTIDAD_PENDIENTEValue: Integer; virtual;
    procedure SetCANTIDAD_PENDIENTEValue(const aValue: Integer); virtual;
    function GetPRECIO_COSTEValue: Currency; virtual;
    procedure SetPRECIO_COSTEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetPRECIO_NETOValue: Float; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Float); virtual;
    function GetPRECIO_PORTEValue: Float; virtual;
    procedure SetPRECIO_PORTEValue(const aValue: Float); virtual;

    { Properties }
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_PEDIDO: String read GetREFERENCIA_PEDIDOValue write SetREFERENCIA_PEDIDOValue;
    property FECHA_PEDIDO: DateTime read GetFECHA_PEDIDOValue write SetFECHA_PEDIDOValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property FECHA_CONFIRMACION: DateTime read GetFECHA_CONFIRMACIONValue write SetFECHA_CONFIRMACIONValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property CANTIDAD_PEDIDA: Integer read GetCANTIDAD_PEDIDAValue write SetCANTIDAD_PEDIDAValue;
    property CANTIDAD_RECIBIDA: Integer read GetCANTIDAD_RECIBIDAValue write SetCANTIDAD_RECIBIDAValue;
    property CANTIDAD_PENDIENTE: Integer read GetCANTIDAD_PENDIENTEValue write SetCANTIDAD_PENDIENTEValue;
    property PRECIO_COSTE: Currency read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property PRECIO_NETO: Float read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property PRECIO_PORTE: Float read GetPRECIO_PORTEValue write SetPRECIO_PORTEValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TINVENTARIODataTableRules }
constructor TINVENTARIODataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TINVENTARIODataTableRules.Destroy;
begin
  inherited;
end;

function TINVENTARIODataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_ALMACEN].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_ALMACEN].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_ARTICULO].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_ARTICULO].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetALMACENValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOALMACEN].AsString;
end;

procedure TINVENTARIODataTableRules.SetALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOALMACEN].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_EMPRESA].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_EMPRESA].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOREFERENCIA].AsString;
end;

procedure TINVENTARIODataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOREFERENCIA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOFAMILIA].AsString;
end;

procedure TINVENTARIODataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOFAMILIA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIODESCRIPCION].AsString;
end;

procedure TINVENTARIODataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIODESCRIPCION].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetPRECIO_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_INVENTARIOPRECIO_NETO].AsCurrency;
end;

procedure TINVENTARIODataTableRules.SetPRECIO_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_INVENTARIOPRECIO_NETO].AsCurrency := aValue;
end;

function TINVENTARIODataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOREFERENCIA_PROVEEDOR].AsString;
end;

procedure TINVENTARIODataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetUNIDADES_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOUNIDADES_ALMACEN].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetUNIDADES_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOUNIDADES_ALMACEN].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetCOSTE_UNIDADESValue: Currency;
begin
  result := DataTable.Fields[idx_INVENTARIOCOSTE_UNIDADES].AsCurrency;
end;

procedure TINVENTARIODataTableRules.SetCOSTE_UNIDADESValue(const aValue: Currency);
begin
  DataTable.Fields[idx_INVENTARIOCOSTE_UNIDADES].AsCurrency := aValue;
end;

function TINVENTARIODataTableRules.GetSTOCKValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOSTOCK].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetSTOCKValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOSTOCK].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetRESERVAValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIORESERVA].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetRESERVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIORESERVA].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetPENDIENTE_RECEPCIONValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOPENDIENTE_RECEPCION].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetPENDIENTE_RECEPCIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOPENDIENTE_RECEPCION].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOCANTIDAD].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOCANTIDAD].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetFECHA_MOVIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_INVENTARIOFECHA_MOVIMIENTO].AsDateTime;
end;

procedure TINVENTARIODataTableRules.SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_INVENTARIOFECHA_MOVIMIENTO].AsDateTime := aValue;
end;

function TINVENTARIODataTableRules.GetCAUSAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOCAUSA].AsString;
end;

procedure TINVENTARIODataTableRules.SetCAUSAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOCAUSA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOTIPO].AsString;
end;

procedure TINVENTARIODataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOTIPO].AsString := aValue;
end;


{ TDETALLE_RESERVAS_INVDataTableRules }
constructor TDETALLE_RESERVAS_INVDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDETALLE_RESERVAS_INVDataTableRules.Destroy;
begin
  inherited;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_EMPRESA].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_EMPRESA].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetSITUACION_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVSITUACION_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetSITUACION_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVSITUACION_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB].AsDateTime;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB].AsDateTime := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ALMACEN_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ALMACEN_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetALMACEN_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVALMACEN_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetALMACEN_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVALMACEN_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_CLIENTE_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_CLIENTE_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetCLIENTE_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVCLIENTE_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetCLIENTE_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVCLIENTE_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ARTValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ART].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ARTValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ART].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetFAMILIA_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVFAMILIA_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetFAMILIA_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVFAMILIA_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_PROV_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_PROV_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetDESCRIPCION_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVDESCRIPCION_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetDESCRIPCION_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVDESCRIPCION_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetCANTIDAD_ARTValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVCANTIDAD_ART].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetCANTIDAD_ARTValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVCANTIDAD_ART].AsInteger := aValue;
end;


{ TDETALLE_SIN_ALBARANARDataTableRules }
constructor TDETALLE_SIN_ALBARANARDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDETALLE_SIN_ALBARANARDataTableRules.Destroy;
begin
  inherited;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetID_PEDIDOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_PEDIDO].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetID_PEDIDOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_PEDIDO].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_EMPRESA].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_EMPRESA].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetREFERENCIA_CLI_PEDIDOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_CLI_PEDIDO].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetREFERENCIA_CLI_PEDIDOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_CLI_PEDIDO].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetREFERENCIA_PEDIDOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_PEDIDO].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetREFERENCIA_PEDIDOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_PEDIDO].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetFECHA_PEDIDOValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARFECHA_PEDIDO].AsDateTime;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetFECHA_PEDIDOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARFECHA_PEDIDO].AsDateTime := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetFECHA_PREVISTA_PEDIDOValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARFECHA_PREVISTA_PEDIDO].AsDateTime;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetFECHA_PREVISTA_PEDIDOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARFECHA_PREVISTA_PEDIDO].AsDateTime := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_CLIENTE].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_CLIENTE].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCLIENTEValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCLIENTE].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCLIENTE].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCALLE].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCALLE].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCODIGO_POSTAL].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCODIGO_POSTAL].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARPOBLACION].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARPOBLACION].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARPROVINCIA].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARPROVINCIA].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARPERSONA_CONTACTO].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARPERSONA_CONTACTO].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetTELEFONOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARTELEFONO].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetTELEFONOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARTELEFONO].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARIVA].AsFloat;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARIVA].AsFloat := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_FORMA_PAGO].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_FORMA_PAGO].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_ARTICULO].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARID_ARTICULO].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARFAMILIA].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARFAMILIA].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_PROVEEDOR].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARDESCRIPCION].AsString;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARDESCRIPCION].AsString := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCANTIDAD_PEDIDAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_PEDIDA].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCANTIDAD_PEDIDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_PEDIDA].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCANTIDAD_RESERVADAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_RESERVADA].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCANTIDAD_RESERVADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_RESERVADA].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCANTIDAD_ENVIADAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_ENVIADA].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCANTIDAD_ENVIADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_ENVIADA].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCANTIDAD_SERVIDAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_SERVIDA].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCANTIDAD_SERVIDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_SERVIDA].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetCANTIDAD_PENDIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_PENDIENTE].AsInteger;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetCANTIDAD_PENDIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARCANTIDAD_PENDIENTE].AsInteger := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetPRECIO_COSTEValue: Currency;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARPRECIO_COSTE].AsCurrency;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetPRECIO_COSTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARPRECIO_COSTE].AsCurrency := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARDESCUENTO].AsFloat;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARDESCUENTO].AsFloat := aValue;
end;

function TDETALLE_SIN_ALBARANARDataTableRules.GetPRECION_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_ALBARANARPRECION_NETO].AsCurrency;
end;

procedure TDETALLE_SIN_ALBARANARDataTableRules.SetPRECION_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_DETALLE_SIN_ALBARANARPRECION_NETO].AsCurrency := aValue;
end;


{ TDETALLE_SIN_RECIBIRDataTableRules }
constructor TDETALLE_SIN_RECIBIRDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDETALLE_SIN_RECIBIRDataTableRules.Destroy;
begin
  inherited;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetID_PEDIDOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_PEDIDO].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetID_PEDIDOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_PEDIDO].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_EMPRESA].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_EMPRESA].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetREFERENCIA_PEDIDOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA_PEDIDO].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetREFERENCIA_PEDIDOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA_PEDIDO].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetFECHA_PEDIDOValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRFECHA_PEDIDO].AsDateTime;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetFECHA_PEDIDOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRFECHA_PEDIDO].AsDateTime := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRCALLE].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRCALLE].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetFECHA_CONFIRMACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRFECHA_CONFIRMACION].AsDateTime;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetFECHA_CONFIRMACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRFECHA_CONFIRMACION].AsDateTime := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_PROVEEDOR].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_PROVEEDOR].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRCODIGO_POSTAL].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRCODIGO_POSTAL].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPOBLACION].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPOBLACION].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPROVINCIA].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPROVINCIA].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPERSONA_CONTACTO].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPERSONA_CONTACTO].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetTELEFONOValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRTELEFONO].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetTELEFONOValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRTELEFONO].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRIVA].AsFloat;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRIVA].AsFloat := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_FORMA_PAGO].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_FORMA_PAGO].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPROVEEDOR].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPROVEEDOR].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_ARTICULO].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRID_ARTICULO].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRFAMILIA].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRFAMILIA].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA_PROVEEDOR].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRDESCRIPCION].AsString;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRDESCRIPCION].AsString := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetCANTIDAD_PEDIDAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_PEDIDA].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetCANTIDAD_PEDIDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_PEDIDA].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetCANTIDAD_RECIBIDAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_RECIBIDA].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetCANTIDAD_RECIBIDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_RECIBIDA].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetCANTIDAD_PENDIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_PENDIENTE].AsInteger;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetCANTIDAD_PENDIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRCANTIDAD_PENDIENTE].AsInteger := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPRECIO_COSTEValue: Currency;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_COSTE].AsCurrency;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPRECIO_COSTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_COSTE].AsCurrency := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRDESCUENTO].AsFloat;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRDESCUENTO].AsFloat := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPRECIO_NETOValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_NETO].AsFloat;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPRECIO_NETOValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_NETO].AsFloat := aValue;
end;

function TDETALLE_SIN_RECIBIRDataTableRules.GetPRECIO_PORTEValue: Float;
begin
  result := DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_PORTE].AsFloat;
end;

procedure TDETALLE_SIN_RECIBIRDataTableRules.SetPRECIO_PORTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_DETALLE_SIN_RECIBIRPRECIO_PORTE].AsFloat := aValue;
end;


initialization
  RegisterDataTableRules(RID_INVENTARIO, TINVENTARIODataTableRules);
  RegisterDataTableRules(RID_DETALLE_RESERVAS_INV, TDETALLE_RESERVAS_INVDataTableRules);
  RegisterDataTableRules(RID_DETALLE_SIN_ALBARANAR, TDETALLE_SIN_ALBARANARDataTableRules);
  RegisterDataTableRules(RID_DETALLE_SIN_RECIBIR, TDETALLE_SIN_RECIBIRDataTableRules);

end.
